
SHOW_DEBUG_OPTIONS = false;

local fireworksY = 250;
local fireworksColumnLeftMargin = 75;
local fireworksColumnWidth = 50;
local fireworksRowTopMargin = 50;
local fireworksRowHeight = 30;

local hobnanigansY = 10;

local fatMayorY = 425;

-- row and column start at 1
function DrawFireworksButton(parent, chatText, column, row)
    local button = Turbine.UI.Lotro.Button();
    button:SetParent(parent)
    button:SetText("[ ]");
    button.Click = function(sender, args) HandleFireworksAnnouncerSay(chatText); end
    button:SetWidth(30);
    button:SetPosition(fireworksColumnLeftMargin + (column -1) * fireworksColumnWidth, fireworksY + fireworksRowTopMargin + (row -1) * fireworksRowHeight);
end

function DrawFireworksLabel(parent, text, column, row)
    local label = Turbine.UI.Label();
    label:SetParent(parent);
    label:SetText(text);
    label:SetPosition(fireworksColumnLeftMargin + (column - 1) * fireworksColumnWidth, fireworksY + fireworksRowTopMargin + (row - 1) * fireworksRowHeight);
    label:SetSize(45, 20);
    label:SetBackColor(Turbine.UI.Color.DarkOliveGreen);
    label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
end

function DrawFireworksDebug(options)
    local blueYesText = "Fireworks Announcer says, ''How about a bright blue one? Launch it now!''\n";
    local greenYesText = "Fireworks Announcer says, ''How about a bright green one? Launch it now!''\n";
    local redYesText = "Fireworks Announcer says, ''How about a bright red one? Launch it now!''\n";
    local yellowYesText = "Fireworks Announcer says, ''How about a bright yellow one? Launch it now!''\n";

    local blueNoText = "Fireworks Announcer says, ''How about something besides blue? Launch it now!''\n";
    local greenNoText = "Fireworks Announcer says, ''How about something besides green? Launch it now!''\n";
    local redNoText = "Fireworks Announcer says, ''How about something besides red? Launch it now!''\n";
    local yellowNoText = "Fireworks Announcer says, ''How about something besides yellow? Launch it now!''\n";

    -- Fireworks in Bree:
    local fireworksHeaderLabel = Turbine.UI.Label();
    fireworksHeaderLabel:SetParent(options);
    fireworksHeaderLabel:SetText("Fireworks in Bree:");
    fireworksHeaderLabel:SetSize(200, 20);
    fireworksHeaderLabel:SetTop(fireworksY);

    DrawFireworksLabel(options, "Yes", 1, 0);
    DrawFireworksLabel(options, "No", 2, 0);

    DrawFireworksLabel(options, "Red", 0, 1);
    DrawFireworksLabel(options, "Green", 0, 2);
    DrawFireworksLabel(options, "Blue", 0, 3);
    DrawFireworksLabel(options, "Yellow", 0, 4);

    DrawFireworksButton(options, redYesText, 1, 1);
    DrawFireworksButton(options, redNoText, 2, 1);
    DrawFireworksButton(options, greenYesText, 1, 2);
    DrawFireworksButton(options, greenNoText, 2, 2);
    DrawFireworksButton(options, blueYesText, 1, 3);
    DrawFireworksButton(options, blueNoText, 2, 3);
    DrawFireworksButton(options, yellowYesText, 1, 4);
    DrawFireworksButton(options, yellowNoText, 2, 4);
end

function DrawHobnanigansDebug(options)
    -- Hobnanigans:
    local hobnanigansHeaderLabel = Turbine.UI.Label();
    hobnanigansHeaderLabel:SetParent(options);
    hobnanigansHeaderLabel:SetText("Hobnanigans:");
    hobnanigansHeaderLabel:SetSize(200, 20);
    hobnanigansHeaderLabel:SetTop(hobnanigansY);
    local y = hobnanigansY + 20;

    -- Header Row
    local ffLabel = Turbine.UI.Label();
    ffLabel:SetParent(options);
    ffLabel:SetBackColor(Turbine.UI.Color.Green);
    ffLabel:SetSize(60, 20);
    ffLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
    ffLabel:SetText("FF");
    ffLabel:SetPosition(150, y);

    local sbLabel = Turbine.UI.Label();
    sbLabel:SetParent(options);
    sbLabel:SetBackColor(Turbine.UI.Color.Green);
    sbLabel:SetSize(60, 20);
    sbLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
    sbLabel:SetText("SB");
    sbLabel:SetPosition(270, y);
    y = y + 30;

    -- Start/Stop quests on Field 2
    local field2Label = Turbine.UI.Label();
    field2Label:SetParent(options);
    field2Label:SetText("Field 2 Quest: ");
    field2Label:SetSize(120, 20);
    field2Label:SetPosition(10, y);
    field2Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

    local startField2QuestFF = Turbine.UI.Lotro.Button();
    startField2QuestFF:SetParent(options)
    startField2QuestFF:SetText("Start");
    startField2QuestFF:SetWidth(50);
    startField2QuestFF:SetPosition(120, y);
    startField2QuestFF.Click = function(sender, args)
        FilterQuest("New Quest: A Game of Hobnanigans -- Flying Feathers - Field 2");
    end

    local stopField2QuestFF = Turbine.UI.Lotro.Button();
    stopField2QuestFF:SetParent(options)
    stopField2QuestFF:SetText("Stop");
    stopField2QuestFF:SetWidth(50);
    stopField2QuestFF:SetPosition(180, y);
    stopField2QuestFF.Click = function(sender, args)
        FilterQuest("Failed: A Game of Hobnanigans -- Flying Feathers - Field 2");
    end

    local startField2QuestSB = Turbine.UI.Lotro.Button();
    startField2QuestSB:SetParent(options)
    startField2QuestSB:SetText("Start");
    startField2QuestSB:SetWidth(50);
    startField2QuestSB:SetPosition(240, y);
    startField2QuestSB.Click = function(sender, args)
        FilterQuest("New Quest: A Game of Hobnanigans -- Steel Beaks - Field 2");
    end

    local stopField2QuestSB = Turbine.UI.Lotro.Button();
    stopField2QuestSB:SetParent(options)
    stopField2QuestSB:SetText("Stop");
    stopField2QuestSB:SetWidth(50);
    stopField2QuestSB:SetPosition(300, y);
    stopField2QuestSB.Click = function(sender, args)
        FilterQuest("Failed: A Game of Hobnanigans -- Steel Beaks - Field 2");
    end
    y = y + 30;

    -- Start/Stop quests on Field 2
    local field3Label = Turbine.UI.Label();
    field3Label:SetParent(options);
    field3Label:SetText("Field 3 Quest: ");
    field3Label:SetSize(120, 20);
    field3Label:SetPosition(10, y);
    field3Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

    local startField3QuestFF = Turbine.UI.Lotro.Button();
    startField3QuestFF:SetParent(options)
    startField3QuestFF:SetText("Start");
    startField3QuestFF.Click = function(sender, args)
        FilterQuest("New Quest: A Game of Hobnanigans -- Flying Feathers - Field 3");
    end
    startField3QuestFF:SetWidth(50);
    startField3QuestFF:SetPosition(120, y);

    local stopField3QuestFF = Turbine.UI.Lotro.Button();
    stopField3QuestFF:SetParent(options)
    stopField3QuestFF:SetText("Stop");
    stopField3QuestFF.Click = function(sender, args)
        FilterQuest("Failed: A Game of Hobnanigans -- Flying Feathers - Field 3");
    end
    stopField3QuestFF:SetWidth(50);
    stopField3QuestFF:SetPosition(180, y);

    local startField3QuestSB = Turbine.UI.Lotro.Button();
    startField3QuestSB:SetParent(options)
    startField3QuestSB:SetText("Start");
    startField3QuestSB.Click = function(sender, args)
        FilterQuest("New Quest: A Game of Hobnanigans -- Steel Beaks - Field 3");
    end
    startField3QuestSB:SetWidth(50);
    startField3QuestSB:SetPosition(240, y);

    local stopField3QuestSB = Turbine.UI.Lotro.Button();
    stopField3QuestSB:SetParent(options)
    stopField3QuestSB:SetText("Stop");
    stopField3QuestSB.Click = function(sender, args)
        FilterQuest("Failed: A Game of Hobnanigans -- Steel Beaks - Field 3");
    end
    stopField3QuestSB:SetWidth(50);
    stopField3QuestSB:SetPosition(300, y);
    y = y + 30;

    -- Begin/End game on field 2:
    local game2Label = Turbine.UI.Label();
    game2Label:SetParent(options);
    game2Label:SetText("Game 2:");
    game2Label:SetSize(120, 20);
    game2Label:SetPosition(10, y);
    game2Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

    local startGame2 = Turbine.UI.Lotro.Button();
    startGame2:SetParent(options)
    startGame2:SetText("Start");
    startGame2.Click = function(sender, args)
        FilterSay("Field 2 Referee says, ''The Game Hen has landed on the field. Begin play!''");
    end
    startGame2:SetWidth(50);
    startGame2:SetPosition(60, y);

    local stopGame2FF = Turbine.UI.Lotro.Button();
    stopGame2FF:SetParent(options)
    stopGame2FF:SetText("Stop");
    stopGame2FF.Click = function(sender, args)
        FilterSay("Field 2 Referee says, ''Flying Feathers Win!!!''"); end
    stopGame2FF:SetWidth(50);
    stopGame2FF:SetPosition(180, y);

    local stopGame2SB = Turbine.UI.Lotro.Button();
    stopGame2SB:SetParent(options)
    stopGame2SB:SetText("Stop");
    stopGame2SB.Click = function(sender, args)
        FilterSay("Field 2 Referee says, ''Steel Beaks Win!!!''"); end
    stopGame2SB:SetWidth(50);
    stopGame2SB:SetPosition(300, y);
    y = y + 30;

    -- Begin/End game on field 2:
    local game3Label = Turbine.UI.Label();
    game3Label:SetParent(options);
    game3Label:SetText("Game 3:");
    game3Label:SetSize(120, 20);
    game3Label:SetPosition(10, y);
    game3Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

    local startGame3 = Turbine.UI.Lotro.Button();
    startGame3:SetParent(options)
    startGame3:SetText("Start");
    startGame3.Click = function(sender, args)
        FilterSay("Field 3 Referee says, ''The Game Hen has landed on the field. Begin play!''");
    end
    startGame3:SetWidth(50);
    startGame3:SetPosition(60, y);

    local stopGame3FF = Turbine.UI.Lotro.Button();
    stopGame3FF:SetParent(options)
    stopGame3FF:SetText("Stop");
    stopGame3FF.Click = function(sender, args)
        FilterSay("Field 3 Referee says, ''Flying Feathers Win!!!''");
    end
    stopGame3FF:SetWidth(50);
    stopGame3FF:SetPosition(180, y);

    local stopGame3SB = Turbine.UI.Lotro.Button();
    stopGame3SB:SetParent(options)
    stopGame3SB:SetText("Stop");
    stopGame3SB.Click = function(sender, args)
        FilterSay("Field 3 Referee says, ''Steel Beaks Win!!!''");
    end
    stopGame3SB:SetWidth(50);
    stopGame3SB:SetPosition(300, y);
    y = y + 30;

    -- Score on field 2/3:
    local game2Score = Turbine.UI.Label();
    game2Score:SetParent(options);
    game2Score:SetText("Score:");
    game2Score:SetSize(120, 20);
    game2Score:SetPosition(10, y);
    game2Score:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

    local game2ScoreFF = Turbine.UI.Lotro.Button();
    game2ScoreFF:SetParent(options)
    game2ScoreFF:SetText("FF2");
    game2ScoreFF.Click = function(sender, args)
        FilterSay("Field 2 Referee says, ''Flying Feathers score!!!''");
    end
    game2ScoreFF:SetWidth(50);
    game2ScoreFF:SetPosition(120, y);

    local game3ScoreFF = Turbine.UI.Lotro.Button();
    game3ScoreFF:SetParent(options)
    game3ScoreFF:SetText("FF3");
    game3ScoreFF.Click = function(sender, args)
        FilterSay("Field 3 Referee says, ''Flying Feathers score!!!''");
    end
    game3ScoreFF:SetWidth(50);
    game3ScoreFF:SetPosition(180, y);

    local game2ScoreSB = Turbine.UI.Lotro.Button();
    game2ScoreSB:SetParent(options)
    game2ScoreSB:SetText("SB2");
    game2ScoreSB.Click = function(sender, args)
        FilterSay("Field 2 Referee says, ''Steel Beaks score!!!''");
    end
    game2ScoreSB:SetWidth(50);
    game2ScoreSB:SetPosition(240, y);

    local game3ScoreSB = Turbine.UI.Lotro.Button();
    game3ScoreSB:SetParent(options)
    game3ScoreSB:SetText("SB3");
    game3ScoreSB.Click = function(sender, args)
        FilterSay("Field 3 Referee says, ''Steel Beaks score!!!''");
    end
    game3ScoreSB:SetWidth(50);
    game3ScoreSB:SetPosition(300, y);
    y = y + 30;

    -- Move time to specific values:
    local gameAdvanceTime = Turbine.UI.Label();
    gameAdvanceTime:SetParent(options);
    gameAdvanceTime:SetText("Advance Time:");
    gameAdvanceTime:SetSize(150, 20);
    gameAdvanceTime:SetPosition(10, y);
    gameAdvanceTime:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);

    local gameTime10minutes = Turbine.UI.Lotro.Button();
    gameTime10minutes:SetParent(options)
    gameTime10minutes:SetText("10 m");
    gameTime10minutes.Click = function(sender, args)
        TimerSetTimeRemaining(hobnanigansTimer, 10 * 60);
    end
    gameTime10minutes:SetWidth(50);
    gameTime10minutes:SetPosition(120, y);

    local gameTime6minutes = Turbine.UI.Lotro.Button();
    gameTime6minutes:SetParent(options)
    gameTime6minutes:SetText("6 m");
    gameTime6minutes.Click = function(sender, args)
        TimerSetTimeRemaining(hobnanigansTimer, 6 * 60 + 2);
    end
    gameTime6minutes:SetWidth(50);
    gameTime6minutes:SetPosition(180, y);

    local gameTime2minutes = Turbine.UI.Lotro.Button();
    gameTime2minutes:SetParent(options)
    gameTime2minutes:SetText("2 m");
    gameTime2minutes.Click = function(sender, args)
        TimerSetTimeRemaining(hobnanigansTimer, 2 * 60 + 2);
    end
    gameTime2minutes:SetWidth(50);
    gameTime2minutes:SetPosition(240, y);

    local gameTime0minutes = Turbine.UI.Lotro.Button();
    gameTime0minutes:SetParent(options)
    gameTime0minutes:SetText("10 s");
    gameTime0minutes.Click = function(sender, args)
        TimerSetTimeRemaining(hobnanigansTimer, 10);
    end
    gameTime0minutes:SetWidth(50);
    gameTime0minutes:SetPosition(300, y);
    y = y + 30;

end

function CreateFarmersFaireFatMayorButton(options, i, y, text, callback)
    local itemButton = Turbine.UI.Lotro.Button();
    itemButton:SetParent(options);
    itemButton:SetPosition(10 + i * 75, y);
    itemButton:SetWidth(65);
    itemButton:SetText(text);
    if (callback ~= nil) then itemButton.Click = callback;
    else
        itemButton.Click = function(sender, args)
            HandleFarmersFaireFatMayorItemClick(text);
        end
    end
    return itemButton;
end

function DrawFarmersFaireFatMayorDebug(options)
    local y = fatMayorY;

    local fatMayorDebugLabel = Turbine.UI.Label();
    fatMayorDebugLabel:SetParent(options);
    fatMayorDebugLabel:SetPosition(0, y);
    fatMayorDebugLabel:SetWidth(200);
    fatMayorDebugLabel:SetText("Farmers Faire - Fat Mayor:")
    y = y + 20;

    CreateFarmersFaireFatMayorButton(options, 0, y, "Butter");
    CreateFarmersFaireFatMayorButton(options, 1, y, "Milk");
    CreateFarmersFaireFatMayorButton(options, 2, y, "Salt");
    CreateFarmersFaireFatMayorButton(options, 3, y, "Water");
    CreateFarmersFaireFatMayorButton(options, 4, y, "Wine");
    y = y + 30;

    CreateFarmersFaireFatMayorButton(options, 1.5, y, "Success", function() HandleFarmersFaireFatMayorResultClick("Success") end);
    CreateFarmersFaireFatMayorButton(options, 2.5, y, "Fail", function() HandleFarmersFaireFatMayorResultClick("Success") end);
    y = y + 30

end

function HandleFarmersFaireFatMayorItemClick(item)
    local mayorSayBegin = "<Select:IID:0x03400000702501C3>Will Whitfoot<\\Select> says, ''";
    local mayorSayEnd = "''";

    local itemSay = {
        ["Butter"] = "It just needs a dab of something....";
        ["Milk"] = "Ack! Ss... spuh... spicy! Save me!";
        ["Salt"] = "It's missing a little something...";
        ["Water"] = "So...thirsty...";
        ["Wine"] = "I must cleanse my palate.";
    };

    local say = mayorSayBegin .. itemSay[item] .. mayorSayEnd;
    FilterSay(say);
end

function HandleFarmersFaireFatMayorResultClick(result)
    if (result == "Success") then
        FilterQuest("You have relieved the mayor (1/6)");
    elseif (result == "Fail") then
        FilterQuest("You did not bring the mayor what he asked for (2/3)");
    end
end

function DrawOptionsWin()
    if (not SHOW_DEBUG_OPTIONS) then return; end

    local options = Turbine.UI.Control();
    options:SetSize(350, 500);
    plugin.GetOptionsPanel = function(self) return options; end

    DrawFireworksDebug(options);
    DrawHobnanigansDebug(options);
    DrawFarmersFaireFatMayorDebug(options);
end


